﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class player : MonoBehaviour
{
    private Animator anim;
    private float h;

    private Rigidbody2D rig2d;
    private Transform groundCheck;
    public bool grounded = false;   // 땅에 있는지 점프하고 있는지 체크하는 변수

    private bool jump = false;      // 점프
    public float jumpForce = 30f;   // 점프에 관여하는 힘

    public bool isJump;             // 꺄항
    public bool startGame = false;  // 시작을 의미하는 변수
    // Use this for initialization
    void Start()
    {
        anim = GetComponent<Animator>();
        rig2d = GetComponent<Rigidbody2D>();
        groundCheck = transform.Find("GroundCheck");
        // 오브젝트중에 "GroundCheck"라는 녀석을 찾아서 연결하기
    }

    // Update is called once per frame
    void Update()
    {
        grounded = Physics2D.Linecast(transform.position, groundCheck.position, 1 << LayerMask.NameToLayer("BlockingLayer"));

        if (isJump)
        {
            if (grounded)
            {
                anim.StopPlayback();
                isJump = false;
            }
        }
        if (Input.GetKey(KeyCode.Space) && grounded)
        {
            jump = true;
            startGame = true;
            anim.SetTrigger("Run");
        }
        if(startGame)
        {
            rig2d.transform.Translate(Vector3.right  * Time.deltaTime);
            // 시간에 비례해서 캐릭터의 움직임을 선정해줍니다.
        }
        
    }
    void FixedUpdate()
    { 
        if (jump)
        {
            jump = false;
            anim.SetTrigger("Jump_Start");
            rig2d.AddForce(new Vector2(0f, jumpForce));
        }
    }
    
    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.tag == "Niddle")
        {
            anim.SetTrigger("Dead");
            rig2d.AddForce(new Vector2(0f, jumpForce * 2));
            GetComponent<BoxCollider2D>().isTrigger = true;
            GetComponent<CircleCollider2D>().isTrigger = true;
            GameObject.Find("Canvas").transform.FindChild("Button").gameObject.SetActive(true);
            // 만약 가시에 닿아서 죽으면 즉시 캔버스 내에 있는 "버튼"을 활성화시킵니다.
        }
    }
    
    public void Response()
    {
        GameObject.Find("Canvas").transform.FindChild("Button").gameObject.SetActive(false);
        GetComponent<BoxCollider2D>().isTrigger = false;
        GetComponent<CircleCollider2D>().isTrigger = false;
        GameObject Response = GameObject.Find("Response");
        gameObject.transform.position = Response.transform.position;
        GameObject.Find("Main Camera").transform.position = new Vector3(0f, 0f, -10f);
        startGame = false;
        anim.SetTrigger("Idle");
    }

    private void OnTriggerEnter2D(Collider2D coll)
    {
        if(coll.gameObject.tag == "Bouns")
        {
            Destroy(coll.gameObject);
            Score.cnt += Random.Range(0, 10);
            Debug.Log(Score.cnt);
        }
    }
}